## fcode-utils 1.0.2

=== Makefile ===
#
#                     OpenBIOS - free your system!
#                             ( Utilities )
#
#  This program is part of a free implementation of the IEEE 1275-1994
#  Standard for Boot (Initialization Configuration) Firmware.
#
#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
#

VERSION:=$(shell grep ^\#.*TOKE_VERSION < toke/toke.c |cut -f2 -d\" )

all:
	make -C toke
	make -C detok
	make -C romheaders

install:
	make -C toke install
	make -C detok install
	make -C romheaders install

clean:	
	make -C toke clean
	make -C detok clean
	make -C romheaders clean
	make -C testsuite clean

distclean: clean
	make -C toke distclean
	make -C detok distclean
	make -C romheaders distclean
	make -C testsuite distclean
	find . -name "*.gcda" -exec rm -f \{\} \;
	find . -name "*.gcno" -exec rm -f \{\} \;

tests: all
	cp toke/toke testsuite
	cp detok/detok testsuite
	cp romheaders/romheaders testsuite
	make -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-ppc-linux
	#make -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-x86-cygwin

# lcov required for html reports
coverage:
	@testsuite/GenCoverage . fcode-suite-$(VERSION) "FCode suite $(VERSION)"
	@testsuite/GenCoverage toke toke-$(VERSION) "Toke $(VERSION)"

.PHONY: all clean distclean toke detok romheaders tests

=== detok/Makefile ===
#
#                     OpenBIOS - free your system!
#                             ( Utilities )
#
#  This program is part of a free implementation of the IEEE 1275-1994
#  Standard for Boot (Initialization Configuration) Firmware.
#
#  Copyright (C) 2001-2006  Stefan Reinauer <stepan@openbios.org>
#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
#

PROGRAM = detok

CC      = gcc
STRIP	= strip
INCLUDES = -I../shared

# Normal Flags:
CFLAGS  = -O2 -Wall -Wno-pointer-sign 
LDFLAGS = 

# Coverage:
#CFLAGS  := $(CFLAGS) -fprofile-arcs -ftest-coverage
#LDFLAGS := $(LDFLAGS) -lgcov

# Debugging:
#CFLAGS := $(CFLAGS) -g


OBJS  = addfcodes.o decode.o detok.o dictionary.o pcihdr.o printformats.o \
        stream.o ../shared/classcodes.o

all: .dependencies $(PROGRAM)

$(PROGRAM): $(OBJS)
	$(CC) -o $(PROGRAM) $(OBJS) $(LDFLAGS)
	$(STRIP) -s $(PROGRAM)

clean:
	rm -f $(OBJS) *~

distclean: clean
	rm -f $(PROGRAM) .dependencies
	
.dependencies: *.c 
	@$(CC) $(CFLAGS) $(INCLUDES) -MM *.c > .dependencies

.PHONY: all clean distclean 

-include .dependencies

.c.o:
	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@

=== romheaders/Makefile ===
#
#                     OpenBIOS - free your system! 
#                             ( Utilities )
#                          
#  This program is part of a free implementation of the IEEE 1275-1994 
#  Standard for Boot (Initialization Configuration) Firmware.
#
#  Copyright (C) 2002  Stefan Reinauer, <stepan@openbios.net>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
#

CC  = gcc
CFLAGS= -O2 -Wall -W -ansi -I../shared

SOURCES = romheaders.c ../shared/classcodes.c

.SUFFIXES: .c

all: romheaders

romheaders: $(SOURCES)
	$(CC) $(CFLAGS) $(SOURCES) -o $@
	strip romheaders
	
clean:
	rm -f *~

distclean: clean
	rm -f romheaders

=== toke/Makefile ===
#
#                     OpenBIOS - free your system!
#                             ( Utilities )
#
#  This program is part of a free implementation of the IEEE 1275-1994
#  Standard for Boot (Initialization Configuration) Firmware.
#
#  Copyright (C) 2001-2006  Stefan Reinauer <stepan@openbios.org>
#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
#

PROGRAM = toke

CC      = gcc
STRIP	= strip
INCLUDES = -I../shared

# Normal flags
CFLAGS  = -O2 -Wall -Wno-pointer-sign -fno-strict-aliasing 
LDFLAGS =

# Coverage:
#CFLAGS  := $(CFLAGS) -fprofile-arcs -ftest-coverage
#LDFLAGS := $(LDFLAGS) -lgcov

# Debugging:
# CFLAGS  := $(CFLAGS) -g

OBJS  = clflags.o conditl.o devnode.o dictionary.o emit.o errhandler.o     \
        flowcontrol.o macros.o nextfcode.o parselocals.o scanner.o stack.o \
	stream.o strsubvocab.o ticvocab.o toke.o tokzesc.o tracesyms.o     \
	usersymbols.o ../shared/classcodes.o

all: .dependencies $(PROGRAM)

$(PROGRAM): $(OBJS)
	$(CC) -o $(PROGRAM) $(OBJS) $(LDFLAGS)
	$(STRIP) -s $(PROGRAM)

clean:
	rm -f $(OBJS) *~

distclean: clean
	rm -f $(PROGRAM) .dependencies
	
.dependencies: *.c 
	@$(CC) $(CFLAGS) $(INCLUDES) -MM *.c > .dependencies

documentation:: *.c *.h toke.doxygen
	@doxygen toke.doxygen

.PHONY: all clean distclean 

-include .dependencies

.c.o:
	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@

=== debian/changelog ===
fcode-utils (1.0.2-8) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Push debhelper level to 13.
  * Set Rules-Requires-Root to no.
  * Bumped Standards-Version to 4.5.0.

  [ Helmut Grohne ]
  * Fix FTCBFS: Don't strip with the build architecture strip (Closes:
    #969116).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 28 Aug 2020 00:09:21 +0200

fcode-utils (1.0.2-7) unstable; urgency=medium

  * Backport 05-bigendian.patch from upstream to fix some issues on big-endian
    machines.
  * Bumped Standards-Version to 3.9.6.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 01 Jan 2016 00:12:22 +0100

fcode-utils (1.0.2-6) unstable; urgency=medium

  * Switch to dh.
  * Bumped Standards-Version to 3.9.5.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 29 May 2014 19:12:43 +0200

fcode-utils (1.0.2-5) unstable; urgency=low

  * Add patches/04-getopt.patch to fix invalid option detection, otherwise
    causing a segmentation fault, as found by Mayhem.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 27 Jun 2013 02:58:55 +0200

fcode-utils (1.0.2-4) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Correctly pass CPPFLAGS and LDFLAGS to build with hardening support.
  * Add ${misc:Depends} to the Depends: field.
  * Add build-arch and build-indep targets.
  * Bumped Standards-Version to 3.9.3 (no changes).
  * Fix doc-base sections.
  * Fix conflicting declaration of variable olen in toke (closes: #688461).

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 07 May 2013 12:46:34 +0200

fcode-utils (1.0.2-3) unstable; urgency=low

  * Support dpkg-buildpackage -j.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 02 Jan 2008 00:29:22 +0100

fcode-utils (1.0.2-2) unstable; urgency=low

  * Build with debugging symbols (closes: bug#436827).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 11 Aug 2007 19:51:17 +0200

fcode-utils (1.0.2-1) unstable; urgency=low

  * Initial Release (closes: bug#419009).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 13 Apr 2007 12:37:19 +0200

=== debian/control ===
Source: fcode-utils
Maintainer: Aurelien Jarno <aurel32@debian.org>
Section: misc
Priority: optional
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: http://www.openbios.org

Package: fcode-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenBIOS FCode utilities
 FCode is a Forth programming language dialect compliant with ANS Forth.
 It can exist in two forms; source code and a compiled version, known as
 bytecode. It is of interest mainly for its use in OpenFirmware.
 .
 This package provides a set of FCode utilities:
  - the tokenizer toke
  - the detokenizer detok
  - a PCI rom header utility
  - a portable implementation of Forth local values

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- STRIP=true

## fcode-utils 1.0.3

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #  This program is part of a free implementation of the IEEE 1275-1994
 #  Standard for Boot (Initialization Configuration) Firmware.
 #
-#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
+#  Copyright (C) 2006-2009 coresystems GmbH
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -21,29 +21,26 @@
 #  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
 #
 
-VERSION:=$(shell grep ^\#.*TOKE_VERSION < toke/toke.c |cut -f2 -d\" )
+VERSION:=$(shell grep "^\#.*TOKE_VERSION" < toke/toke.c |cut -f2 -d\" )
 
 all:
-	make -C toke
-	make -C detok
-	make -C romheaders
+	$(MAKE) -C toke
+	$(MAKE) -C detok
+	$(MAKE) -C romheaders
 
 install:
-	make -C toke install
-	make -C detok install
-	make -C romheaders install
+	$(MAKE) -C toke install
+	$(MAKE) -C detok install
+	$(MAKE) -C romheaders install
 
 clean:	
-	make -C toke clean
-	make -C detok clean
-	make -C romheaders clean
-	make -C testsuite clean
+	$(MAKE) -C toke clean
+	$(MAKE) -C detok clean
+	$(MAKE) -C romheaders clean
+	$(MAKE) -C testsuite clean
 
 distclean: clean
-	make -C toke distclean
-	make -C detok distclean
-	make -C romheaders distclean
-	make -C testsuite distclean
+	$(MAKE) -C testsuite distclean
 	find . -name "*.gcda" -exec rm -f \{\} \;
 	find . -name "*.gcno" -exec rm -f \{\} \;
 
@@ -51,8 +48,8 @@
 	cp toke/toke testsuite
 	cp detok/detok testsuite
 	cp romheaders/romheaders testsuite
-	make -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-ppc-linux
-	#make -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-x86-cygwin
+	$(MAKE) -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-ppc-linux
+	#$(MAKE) -C testsuite all CygTestLogs=`pwd`/testlogs/testlogs-x86-cygwin
 
 # lcov required for html reports
 coverage:

=== detok/Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #
 #                     OpenBIOS - free your system!
-#                             ( Utilities )
+#                        ( FCode detokenizer )
 #
 #  This program is part of a free implementation of the IEEE 1275-1994
 #  Standard for Boot (Initialization Configuration) Firmware.
 #
-#  Copyright (C) 2001-2006  Stefan Reinauer <stepan@openbios.org>
-#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
+#  Copyright (C) 2001-2010  Stefan Reinauer
+#  Copyright (C) 2006-2009 coresystems GmbH
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -24,12 +24,13 @@
 
 PROGRAM = detok
 
-CC      = gcc
+DESTDIR = /usr/local
+CC      ?= gcc
 STRIP	= strip
 INCLUDES = -I../shared
 
 # Normal Flags:
-CFLAGS  = -O2 -Wall -Wno-pointer-sign 
+CFLAGS  = -O2 -Wall #-Wextra
 LDFLAGS = 
 
 # Coverage:
@@ -47,21 +48,22 @@
 
 $(PROGRAM): $(OBJS)
 	$(CC) -o $(PROGRAM) $(OBJS) $(LDFLAGS)
-	$(STRIP) -s $(PROGRAM)
+	$(STRIP) $(PROGRAM)
 
 clean:
 	rm -f $(OBJS) *~
+	rm -f $(PROGRAM) .dependencies
 
-distclean: clean
-	rm -f $(PROGRAM) .dependencies
-	
 .dependencies: *.c 
 	@$(CC) $(CFLAGS) $(INCLUDES) -MM *.c > .dependencies
 
-.PHONY: all clean distclean 
+.PHONY: all clean
 
 -include .dependencies
 
 .c.o:
 	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@ 
 
+install:
+	mkdir -p $(DESTDIR)/bin
+	cp $(PROGRAM) $(DESTDIR)/bin/$(PROGRAM)

=== romheaders/Makefile ===
--- 
+++ 
@@ -5,7 +5,8 @@
 #  This program is part of a free implementation of the IEEE 1275-1994 
 #  Standard for Boot (Initialization Configuration) Firmware.
 #
-#  Copyright (C) 2002  Stefan Reinauer, <stepan@openbios.net>
+#  Copyright (C) 2002-2010 Stefan Reinauer
+#  Copyright (C) 2009 coresystems GmbH
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -21,8 +22,13 @@
 #  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02110-1301 USA
 #
 
-CC  = gcc
-CFLAGS= -O2 -Wall -W -ansi -I../shared
+PROGRAM = romheaders
+
+DESTDIR  = /usr/local
+CC	 ?= gcc
+STRIP    = strip
+CFLAGS   = -O2 -Wall -Wextra
+INCLUDES = -I../shared
 
 SOURCES = romheaders.c ../shared/classcodes.c
 
@@ -31,11 +37,13 @@
 all: romheaders
 
 romheaders: $(SOURCES)
-	$(CC) $(CFLAGS) $(SOURCES) -o $@
-	strip romheaders
-	
+	$(CC) $(CFLAGS) $(INCLUDES) $(SOURCES) -o $@
+	$(STRIP) romheaders
+
 clean:
 	rm -f *~
+	rm -f $(PROGRAM)
 
-distclean: clean
-	rm -f romheaders
+install:
+	mkdir -p $(DESTDIR)/bin
+	cp $(PROGRAM) $(DESTDIR)/bin/$(PROGRAM)

=== testsuite/Makefile ===
all: tests compare

tests:
	@echo "starting testsuite"
	@csh AutoExec

compare:
	CygTestLogs=$(CygTestLogs) csh AutoCompare

clean:
	find . -name "*.DeTok" -a ! -name "*.OldTkzr.DeTok" -exec rm -f \{\} \;
	find . -name "*.Log" -a ! -name "*.OldTkzr.Log" -exec rm -f \{\} \;
	find . -name "*.fc" -a ! -name "*.OldTkzr.fc" -exec rm -f \{\} \;
	find . -name "*.fl" -exec rm -f \{\} \;
	find . -name "*.RomHdr" -exec rm -f \{\} \;
	find . -name "*.P" -exec rm -f \{\} \;
	find . -name "*.missing" -exec rm -f \{\} \;

distclean: clean
	rm -f toke detok romheaders
	rm -f AutoComp.Log.*
	rm -f AutoComp.TKdiffs.*

=== toke/Makefile ===
--- 
+++ 
@@ -5,8 +5,8 @@
 #  This program is part of a free implementation of the IEEE 1275-1994
 #  Standard for Boot (Initialization Configuration) Firmware.
 #
-#  Copyright (C) 2001-2006  Stefan Reinauer <stepan@openbios.org>
-#  Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
+#  Copyright (C) 2001-2006 Stefan Reinauer
+#  Copyright (C) 2006-2009 coresystems GmbH
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -24,12 +24,13 @@
 
 PROGRAM = toke
 
-CC      = gcc
+DESTDIR = /usr/local
+CC      ?= gcc
 STRIP	= strip
 INCLUDES = -I../shared
 
 # Normal flags
-CFLAGS  = -O2 -Wall -Wno-pointer-sign -fno-strict-aliasing 
+CFLAGS  = -O2 -Wall #-Wextra 
 LDFLAGS =
 
 # Coverage:
@@ -38,6 +39,12 @@
 
 # Debugging:
 # CFLAGS  := $(CFLAGS) -g
+
+# for gcc 4. remove if you fixed the code.
+_GCC4_CFLAGS=$(shell echo 'main(int argc, char **argv){return 0;}' > .test.c;   \
+		$(CC) -Wno-pointer-sign -c .test.c -o .test.o > /dev/null 2>&1 \
+		&& echo -Wno-pointer-sign; rm .test.c .test.o )
+CFLAGS  := $(CFLAGS) $(_GCC4_CFLAGS)
 
 OBJS  = clflags.o conditl.o devnode.o dictionary.o emit.o errhandler.o     \
         flowcontrol.o macros.o nextfcode.o parselocals.o scanner.o stack.o \
@@ -48,24 +55,25 @@
 
 $(PROGRAM): $(OBJS)
 	$(CC) -o $(PROGRAM) $(OBJS) $(LDFLAGS)
-	$(STRIP) -s $(PROGRAM)
+	$(STRIP) $(PROGRAM)
 
 clean:
 	rm -f $(OBJS) *~
+	rm -f $(PROGRAM) .dependencies
 
-distclean: clean
-	rm -f $(PROGRAM) .dependencies
-	
 .dependencies: *.c 
 	@$(CC) $(CFLAGS) $(INCLUDES) -MM *.c > .dependencies
 
 documentation:: *.c *.h toke.doxygen
 	@doxygen toke.doxygen
 
-.PHONY: all clean distclean 
+.PHONY: all clean
 
 -include .dependencies
 
 .c.o:
 	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@ 
 
+install:
+	mkdir -p $(DESTDIR)/bin
+	cp $(PROGRAM) $(DESTDIR)/bin/$(PROGRAM)

=== debian/changelog ===
fcode-utils (1.0.3-2) unstable; urgency=medium

  * No change upload, except adding missing changelog entries in previous
    version

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 09 Mar 2025 23:20:18 +0100

fcode-utils (1.0.3-1) unstable; urgency=medium

  * New upstream release
  * Drop debian/patches/01-sys-types-h.patch, upstreamed
  * Replace debian/patches/03-makefile.patch by upstream patch
  * Drop debian/patches/05-bigendian.patch, upstreamed
  * Drop debian/patches/nostrip.patch, upstreamed
  * Update debian/rules following changes to upstream Makefiles
  * Rewrite debian/copyright in Machine-readable format
  * Update homepage in debian/control
  * Bump Standards-Version to 4.7.2 (no changes)
  * Add debian/watch file
  * Force standards to gnu99 to fix build with GCC 15 (Closes: #1096621)
  * Set DEB_BUILD_MAINT_OPTIONS = hardening=+all to make lintian happier
  * Add Vcs-git and Vcs-browser to debian/control

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 09 Mar 2025 21:29:38 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,14 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
-Homepage: http://www.openbios.org
+Standards-Version: 4.7.2
+Homepage: https://github.com/openbios/fcode-utils
+Vcs-Git: https://salsa.debian.org/aurel32/fcode-utils.git
+Vcs-Browser: https://salsa.debian.org/aurel32/fcode-utils
 
 Package: fcode-utils
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: OpenBIOS FCode utilities
  FCode is a Forth programming language dialect compliant with ANS Forth.
  It can exist in two forms; source code and a compiled version, known as

=== debian/rules ===
#!/usr/bin/make -f

# code use the "bool", which is a reserved keyword in C23. Downgrade to GNU99
export DEB_CFLAGS_MAINT_APPEND=-std=gnu99

# this make lintian happier
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- STRIP=true CFLAGS="$$CPPFLAGS $$CFLAGS" LDFLAGS="$$LDFLAGS"

override_dh_auto_install:
	# Installation is done using debian/install

=== debian/watch ===
version=4
https://github.com/openbios/fcode-utils/tags .*/v@ANY_VERSION@@ARCHIVE_EXT@
